"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createContext = void 0;

var _coreFunctions = _interopRequireDefault(require("./core-functions"));

var _state = require("./state");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const createContext = ({
  state = (0, _state.createReactiveState)(),
  variables = _coreFunctions.default
} = {}) => {
  const setVariable = (key, value) => {
    return extend(context, {
      variables: { ...variables,
        [key]: value
      }
    });
  };

  const assignVariables = assignments => {
    return extend(context, {
      variables: { ...variables,
        ...assignments
      }
    });
  };

  const context = {
    state,
    variables: Object.freeze(variables),
    setVariable,
    assignVariables
  };
  return context;
};

exports.createContext = createContext;

const extend = ({
  state,
  variables
}, changes) => {
  return createContext({
    state,
    variables,
    ...changes
  });
};