"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _compute = require("../compute");

const lambdas = {
  'bind': (context, [fnName, ...boundArgs], onValue) => {
    const bound = (__, args, _onValue) => {
      (0, _compute.compute)(context, [fnName].concat(boundArgs, args), _onValue);
    };

    onValue({
      value: bound,
      context
    });
  },
  'lambda': (context, [argNames, statements], onValue) => {
    const lambda = (__, args, _onValue) => {
      const next = (_context, _statements) => {
        if (_statements.length === 0) {
          _onValue({
            context,
            value: undefined
          });

          return;
        }

        (0, _compute.compute)(_context, _statements[0], result => {
          if (_statements.length > 1) {
            next(result.context, _statements.slice(1));
            return;
          }

          _onValue({
            context,
            value: result.value
          });
        });
      };

      const contextWithArgs = argNames.reduce((_context, name, i) => {
        return _context.setVariable(name, args[i]);
      }, context);
      next(contextWithArgs, statements);
    };

    lambda.code = ['lambda', ['.', ...argNames], ['.', ...statements]];
    lambda.context = context;
    onValue({
      value: lambda,
      context
    });
  }
};
var _default = lambdas;
exports.default = _default;