"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createMachine = void 0;

var _compute = require("./compute");

const createMachine = environment => {
  const run = (root, inputs = [], onValue) => {
    (0, _compute.compute)(environment, root, result => {
      if (typeof result.value === 'function') {
        result.value(environment, inputs, onValue);
      } else {
        onValue(result);
      }
    });
  };

  const extend = extensions => {
    return createMachine(environment.assignVariables(extensions));
  };

  return {
    run,
    extend
  };
};

exports.createMachine = createMachine;